declare('PVP', {version = '1.02'})
--
--
--  Written by Lisa201
--	
--
local PVPon = false
local PVPHealth = 20
local PVPTimer = Timer()
local PVPMyHealth = 100
local PVPTargetHealth = 100
local PVPCheckTime = 500
local PlayerName = GetPlayerName(GetCharacterID())
local TargetName = ""
local audio_loaded = false

-------------------------------------------------------------
-- PVP health check
-------------------------------------------------------------
function PVP.Check()
	TargetName, PVPTargetHealth = GetTargetInfo()
	if not TargetName then TargetName ="NO Target" end
	if not PVPTargetHealth then PVPTargetHealth = 1 end
	PVPTargetHealth = PVPTargetHealth *100
	PVPMyHealth = GetPlayerHealth(GetCharacterID())
	if PVPMyHealth < PVPHealth or PVPTargetHealth < PVPHealth then
		gksound.GKPlaySound("PVPStop", 1.0)
		PVP.Stop()
	else
		PVPTimer:SetTimeout(PVPCheckTime,PVP.Check) --Keep watching healths
	end
end

-------------------------------------------------------------
-- PVP tool
-------------------------------------------------------------
function PVP.Start(_,mydata)
	if not audio_loaded then
		audio_loaded = true
		gksound.GKLoadSound{soundname="PVPStop", filename="plugins/PVP/audio/Beep.ogg"};
		print("sound loaded")
	end
	
	if mydata then 
		PVPHealth = tonumber(mydata[1])
	end
	PlayerName = GetPlayerName(GetCharacterID())
	print("PVP Health set to: ".. PVPHealth)
	PVPTimer:SetTimeout(PVPCheckTime,PVP.Check)
end

-------------------------------------------------------------
-- Round numbers 
-------------------------------------------------------------
function round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

-------------------------------------------------------------
-- PVP tool stop
-------------------------------------------------------------
function PVP.Stop()
	PVPTimer:Kill()
	local winner = "None"
	local loser = "None"
	local winhealth = 0
	local loserhealth = 0
	if PVPMyHealth < PVPTargetHealth then
		winner = TargetName
		winhealth = PVPTargetHealth
		loser = PlayerName
		loserhealth = PVPMyHealth
	else
		loser = TargetName
		loserhealth = PVPTargetHealth
		winner = PlayerName
		winhealth = PVPMyHealth
	end
	
	local msg ="say_sector Good Fight!    "..winner.." @ "..round(winhealth,1).."%      VS      "..loser.." @ "..round(loserhealth,1).."%"
	gkinterface.GKProcessCommand(msg)
end

-------------------------------------------------------------
RegisterUserCommand("pvpstart",PVP.Start)
RegisterUserCommand("pvpstop",PVP.Stop)
